class String
    
  def shift
    # Removes first character from self and 
    #   returns it, changing self
    return nil if self.empty?
    item=self[0]
    self.sub!(/^./,"")
    return nil if item.nil?
    item.chr
  end

  def unshift(other)
    # Adds last character of provided string to 
    #   front of self
    newself = other.to_s.dup.pop.to_s + self
    self.replace(newself)
  end

  def pop
    # Pops last character off self and 
    #   returns it, changing self
    return nil if self.empty?
    item=self[-1]
    self.chop!
    return nil if item.nil?
    item.chr
  end

  def push(other)
    # Pushes first character of provided 
    #   string onto end of self
    newself = self + other.to_s.dup.shift.to_s
    self.replace(newself)
  end

  def rotate_left(n=1)
    n=1 unless n.kind_of? Integer
    n.times do
      char = self.shift
      self.push(char)
    end
    self
  end

  def rotate_right(n=1)
    n=1 unless n.kind_of? Integer
    n.times do
      char = self.pop
      self.unshift(char)
    end
    self
  end

  @@first_word_re = /^(\w+\W*)/
  @@last_word_re = /(\w+\W*)$/

  def shift_word
    # Shifts first word off of self 
    #   and returns; changes self
    return nil if self.empty?
    self=~@@first_word_re
    newself= $' || ""       # $' is POSTMATCH
    self.replace(newself) unless $'.nil?
    $1
  end

  def unshift_word(other)
    # Adds provided string to front of self
    newself = other.to_s + self
    self.replace(newself)
  end

  def pop_word
    # Pops and returns last word off 
    # self; changes self
    return nil if self.empty?
    self=~@@last_word_re
    newself= $` || ""       # $` is PREMATCH
    self.replace(newself) unless $`.nil?
    $1
  end

  def push_word(other)
    # Pushes provided string onto end of self
    newself = self + other.to_s
    self.replace(newself)
  end

  def rotate_word_left
    word = self.shift_word
    self.push_word(word)
  end

  def rotate_word_right
    word = self.pop_word
    self.unshift_word(word)
  end

  alias rotate_Left rotate_word_left
  alias rotate_Right rotate_word_right

end

# ------------

str = "Hello there"
puts str.rotate_left                # "ello thereH"
puts str.pop                        # "H"
puts str.shift                      # "e"
puts str.rotate_right               # "ello ther"
puts str.unshift("H")               # "Hello ther"
puts str.push("e")                  # "Hello there"

puts str.push_word(", pal!")        # "Hello there, pal!"
puts str.rotate_Left                # "there, pal!Hello "

puts str.pop_word                   # str is "there, pal!"
                                    # result is "Hello "

puts str.shift_word                 # str is "pal!"
                                    # result is "there, "

puts str.unshift_word("Hi there, ") # "Hi there, pal!"
puts str.rotate_Right               # "pal!Hi there, "
puts str.rotate_left(4)             # "Hi there, pal!"

puts "Trying again..."
str = "pal! Hi there, "
puts str.rotate_left(5)             # "Hi there, pal!"
