class IOString < String
    
  def initialize(str="")
    @fptr = 0
    self.replace(str)
  end

  def open
    @fptr = 0
  end

  def truncate
    self.replace("")
    @fptr = 0
  end

  def seek(n)
    @fptr = [n, self.size].min
  end

  def tell
    @fptr
  end

  def getc
    @fptr += 1
    self[@fptr-1].to_i
  end

  def ungetc(c)
    self[@fptr -= 1] = c.chr
  end

  def putc(c)
    self[@fptr] = c.chr
    @fptr += 1
  end

  def gets
    s = ""
    n = self.index("\n",@fptr)
    s = self[@fptr..n].dup
    @fptr += s.length
    s
  end

  def puts(s)
    self[@fptr..@fptr+s.length-1] = s
    @fptr += s.length
  end

end
    
    
    
ios = IOString.new("abcdefghijkl\nABC\n123")

ios.seek(5)
ios.puts("xyz")

puts ios.tell      # 8

puts ios.dump      # "abcdexyzijkl\nABC\n123"

c = ios.getc
puts "c = #{c}"    # c = 105

ios.ungetc(?w)

puts ios.dump      # "abcdexyzwjkl\nABC\n123"

puts "Ptr = #{ios.tell}"

s1 = ios.gets      # "wjkl"
s2 = ios.gets      # "ABC"
