class Class

  def cattr_reader(*syms)
    syms.each do |sym| 
      class_eval <<-EOS
        if ! defined? @@#{sym.id2name}
          @@#{sym.id2name} = nil 
        end
        def self.#{sym.id2name}
          @@#{sym}
        end
      EOS
    end
  end

  def cattr_writer(*syms)
    syms.each do |sym| 
      class_eval <<-EOS
        if ! defined? @@#{sym.id2name}
          @@#{sym.id2name} = nil 
        end
        def self.#{sym.id2name}=(obj)
          @@#{sym.id2name} = obj
        end
      EOS
    end
  end

  def cattr_accessor(*syms)
    cattr_reader(*syms)
    cattr_writer(*syms)
  end

end


class MyClass

  @@alpha = 123                # Initialize @@alpha

  cattr_reader :alpha          # MyClass.alpha()
  cattr_writer :beta           # MyClass.beta=()
  cattr_accessor :gamma        # MyClass.gamma() and
                               #   MyClass.gamma=()

  def MyClass.look
    puts "#@@alpha, #@@beta, #@@gamma"
  end

  #...

end


puts MyClass.alpha             # 123
MyClass.beta = 456
MyClass.gamma = 789
puts MyClass.gamma             # 789

MyClass.look                   # 123, 456, 789
