module Trace

  def Trace.append_features(into)
    into.instance_methods.each { |m| Trace.hook_method(into, m) }
    def into.method_added(method)
      unless @adding
        @adding = true
        Trace.hook_method(self, method)
        @adding = false
      end
    end
    super
  end

  def Trace.hook_method(klass, method)
    klass.class_eval <<-EOD
    alias :old_#{method}  :#{method}
    def #{method}(*args)
      puts "#{method} called. Params = #{args.join(', ')}"
      old_#{method}(*args)
    end
    EOD
  end

end
