require "gtk"

class TicketWindow < Gtk::Window

  def initialize
    super
    set_title("Purchase Ticket")
    signal_connect("destroy") { Gtk::main_quit }

    @destination = Gtk::CList.new(["Destination", "Country"])
    @destination.append(["Cairo", "Egypt"]);
    @destination.append(["New York", "USA"]);
    @destination.append(["Tokyo", "Japan"]);
    @destination.signal_connect("select_row") do
      |list,row,col,event| 
      @city = @destination.get_text(row, 0)
    end
    @destination.select_row(0, 0)

    @roundTrip = Gtk::CheckButton.new("Round Trip")

    purchase = Gtk::Button.new("Purchase")
    purchase.signal_connect("clicked") { cmdPurchase }

    @result = Gtk::Label.new("")

    @coach = Gtk::RadioButton.new(nil, "Coach class")
    @business = Gtk::RadioButton.new(@coach, "Business class")
    @first = Gtk::RadioButton.new(@business, "First class")

    flightBox = Gtk::VBox.new
    flightBox.add(@destination)
    flightBox.add(@roundTrip)

    seatBox = Gtk::VBox.new
    seatBox.add(@coach)
    seatBox.add(@business)
    seatBox.add(@first)

    topBox = Gtk::HBox.new
    topBox.add(flightBox)
    topBox.add(seatBox)

    mainBox = Gtk::VBox.new
    mainBox.add(topBox)
    mainBox.add(purchase)
    mainBox.add(@result)

    add(mainBox)
    show_all
  end

  def cmdPurchase
    text = @city
    if(@first.active?)
      text += ": first class"
    elsif(@business.active?)
      text += ": business class"
    elsif(@coach.active?)
      text += ": coach"
    end
    if(@roundTrip.active?) then text += ", round trip " end
    @result.set_text(text)
  end

end

TicketWindow.new
Gtk::main
