require "gtk"

class MenuWindow < Gtk::Window

  def initialize
    super
    set_title("Ruby/GTK Menu Sample")
    signal_connect("destroy") { Gtk::main_quit }

    fileExitItem = Gtk::MenuItem.new("Exit")
    fileExitItem.signal_connect("activate") { Gtk::main_quit }

    fileMenu = Gtk::Menu.new
    fileMenu.add(fileExitItem)

    fileMenuItem = Gtk::MenuItem.new("File")
    fileMenuItem.set_submenu(fileMenu)

    menuBar = Gtk::MenuBar.new
    menuBar.append(fileMenuItem)
    menuBar.append(Gtk::MenuItem.new("Nothing"))
    menuBar.append(Gtk::MenuItem.new("Useless"))

    tooltips = Gtk::Tooltips.new
    tooltips.set_tip(fileMenuItem, "File Menu", "")
    tooltips.set_tip(fileExitItem, "Exit the app", "")

    box = Gtk::VBox.new
    box.pack_start(menuBar, false, false, 0)
    box.add(Gtk::Label.new("Try the menu and tooltips!"))

    add(box)
    set_default_size(300, 100)
    show_all
  end

end

MenuWindow.new
Gtk::main
