require "fox"
require "responder"

include Fox

class SimpleMessageHandlerWindow < FXMainWindow

  include Responder

  # Message identifiers for this class
  ID_HELLO_WORLD = FXMainWindow::ID_LAST

  def initialize(app)
    # Invoke base class initialize first
    super(app, "Simple Message Handler", nil, nil, 
          DECOR_TITLE | DECOR_CLOSE)

    # Define the message map for the class
    FXMAPFUNC(SEL_COMMAND, ID_HELLO_WORLD, 
              "onCmdHelloWorld")

    # The button
    FXButton.new(self, "&Hello, World", nil, self, 
                 ID_HELLO_WORLD)
  end

  def onCmdHelloWorld(sender, sel, ptr)
    puts "Hello, World"
  end

end

def run
  application = FXApp.new("SimpleButton", 
                          "Sample programs")
  application.init(ARGV)
  main = SimpleMessageHandlerWindow.new(application)
  application.create
  main.show(PLACEMENT_SCREEN)
  application.run
end

run
