require "fox"
require "responder"

include Fox

class ListHandlerWindow < FXMainWindow

  include Responder

  # Message identifiers for this class
  ID_SELECT = FXMainWindow::ID_LAST

  def initialize(app)
    # Invoke base class initialize first
    super(app, "List Handler", nil, nil, 
          DECOR_TITLE | DECOR_CLOSE)

    # Define the message map for the class
    FXMAPFUNC(SEL_COMMAND, ID_SELECT, 
              "onCmdSelect")

    @list = FXList.new(self, 5, self, ID_SELECT, 
                       LIST_BROWSESELECT | 
                       LAYOUT_FILL_X)
    @names = ["Chuck", "Sally", "Franklin", 
              "Schroeder", "Woodstock", 
              "Matz", "Lucy"]
    @names.each {|each| @list.appendItem(each) }
  end

  def onCmdSelect(sender, sel, i)
    puts i.to_s + " => " + @names[i]
  end
end

def run
  application = FXApp.new("List", 
                          "Sample programs")
  application.init(ARGV)
  main = ListHandlerWindow.new(application)
  application.create
  main.show(PLACEMENT_SCREEN)
  application.run
end

run
