def delete_if(dir)
  save = Dir.getwd
  Dir.chdir(dir)
  Dir.foreach(".") do |entry|
    # We're not handling directories here
    next if File.stat(entry).directory?
    if yield entry
      File.unlink(entry)
    end
  end
  Dir.chdir(save)
end

# Delete all files over 3000 bytes
delete_if("/tmp") { |f| File.size(f) > 3000 }

# Delete all LOG and BAK files
delete_if("/tmp") { |f| f =~ /(log|bak)$/i }
