#!/usr/local/bin/ruby
require "cgi"
require "cgi/session"
$session = nil

def header(cgi)
  "<B>Welcome, #{get_session(cgi)['user']}!</B> - " +
  "<i><a href=\"/cgi-bin/rb/board.cgi?cmd=post\">" +
  "post a message</a></i> - <i>" +
  "<a href=\"/cgi-bin/rb/board.cgi?cmd=mainlist\">home</a>." + 
  <BR><HR>"
end

def do_oops_page(cgi, err)
  cgi.out do
    cgi.html do
      cgi.body do
        "It appears that you have invoked the" +
        " message board incorrectly. Oops.<BR>|#{err}|"
      end
    end
  end
end

def do_login_page(cgi)
  cgi.out do
    cgi.html do
      cgi.body do
        cgi.h1 { "Welcome to Ruby Board" } +
        cgi.b { "Please Login:" } +
        cgi.form("METHOD" => "get", 
                 "action" => "/cgi-bin/rb/board.cgi") do
          cgi.text_field({ "name" => "user" })  + 
          cgi.submit("Login") + 
          cgi.input({"name" => "cmd", 
                     "value" => "authenticate", 
                     "type" => "hidden"}) + 
          cgi.input({"name" => "page", 
                     "value" => "#{cgi['cmd'][0]}", 
                     "type" => "hidden"}) 
        end
      end
    end
  end
end

def run_command(cgi)
  command = cgi['cmd'][0]
  if command == "" || command == nil  
    command = "mainlist"
  end
  if command_safe?(command)
    methname = "do_#{command}_page"
  else
    do_oops_page(cgi, "Command \"#{command}\"" + 
                      " inappropriately formatted.")
  end
  begin
    eval "#{methname}(cgi)"
  rescue NameError
    begin
      require "#{command}.rb"
    rescue LoadError
      do_oops_page(cgi, "Error loading #{command}")
    end
  end
  eval "#{methname}(cgi)"
  exit
  
end

def command_safe?(command)
  if command =~ (/^[a-zA-Z0-9]+$/) then 
    return true
  end
  false
end

def get_session(cgi)
  if $session == nil then
    $session = CGI::Session.new( cgi, "session_key" => "a_test",
                                      "prefix" => "rubysess.")
  end
  return $session
end

def validate_session(cgi)
  session = get_session(cgi)
  if cgi["user"][0] =~ /[a-zA-Z0-9]/
    return
  end
  if session["user"] !~ /[a-zA-Z0-9]/
    do_login_page(cgi)
  end
end

if __FILE__ == $0 then
  cgi = CGI.new("html4")
  validate_session(cgi)
  err = run_command(cgi)
end
